package info.bukova.isspst.mail;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.beanutils.BeanUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class EntityMessageBuilder implements MessageBuilder {
	
	private final static Logger logger = LoggerFactory.getLogger(EntityMessageBuilder.class);

	@Override
	public MailMessage buildMessage(MailMessage template, Object data) {
		MailMessage msg = new MailMessage(template);
		msg.setSubject(replacaProperties(msg.getSubject(), data));
		msg.setText(replacaProperties(msg.getText(), data));
		return msg;
	}
	
	private String replacaProperties(String src, Object data) {
		int current = 0;
		List<String> properties = new ArrayList<String>();
		boolean found = false;
		String ret = src;
		
		do {
			int openIndex = src.indexOf("[", current);
			int closeIndex = src.indexOf("]", current);
			if (openIndex != -1) {
				String property = src.substring(openIndex + 1, closeIndex);
				if (!properties.contains(property)) {
					properties.add(property);
				}
				found = true;
			} else {
				found = false;
			}
			current = closeIndex + 1;
		} while (found);
		
		for (String p : properties) {
			try {
				ret = ret.replaceAll("\\[" + p + "\\]", BeanUtils.getProperty(data, p));
			} catch (IllegalAccessException e) {
				logger.error(e.getMessage());
			} catch (InvocationTargetException e) {
				logger.error(e.getMessage());
			} catch (NoSuchMethodException e) {
				logger.error(e.getMessage());
			}
		}
		
		return ret;
	}

}
