package info.bukova.isspst.ui.requirement;

import info.bukova.isspst.data.MUnitEmb;
import info.bukova.isspst.data.Material;
import info.bukova.isspst.data.RequirementSubject;
import info.bukova.isspst.data.ServiceItem;
import info.bukova.isspst.filters.MaterialFilter;
import info.bukova.isspst.filters.ServiceItemFilter;
import info.bukova.isspst.services.munits.MUnitService;
import info.bukova.isspst.services.reqsubjects.MaterialService;
import info.bukova.isspst.services.reqsubjects.ServiceItemService;

import java.util.List;

import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.Init;
import org.zkoss.bind.annotation.NotifyChange;
import org.zkoss.zk.ui.select.annotation.WireVariable;

public class SelectItems
{
	@WireVariable
	private MaterialService materialService;

	private List<Material> materialList;

	private List<Material> fullMaterialList;
	

	private boolean activeFilterMaterial;

	private Material filterTmpMaterial;

	private MaterialFilter dataFilterMaterial;


	@WireVariable
	private ServiceItemService serviceItemService;

	private List<ServiceItem> serviceItemList;

	private List<ServiceItem> fullServiceItemList;

	
	private boolean activeFilterService;

	private ServiceItem filterTmpService;

	private ServiceItemFilter dataFilterService;


	private RequirementSubject selectedItem;

	@WireVariable
	private MUnitService munitService;

	private List<MUnitEmb> munitList;


	@Init
	public void init()
	{
		this.setFullMaterialList(materialService.getAll());
		this.setMaterialList(this.getFullMaterialList());

		this.setActiveFilterMaterial(false);
		this.setFilterTmpMaterial(new Material());
		this.setDataFilterMaterial(new MaterialFilter(this.getFilterTmpMaterial()));


		this.setFullServiceItemList(serviceItemService.getAll());
		this.setServiceItemList(this.getFullServiceItemList());

		this.setActiveFilterService(false);
		this.setFilterTmpService(new ServiceItem());
		this.setDataFilterService(new ServiceItemFilter(this.getFilterTmpService()));

		this.setMunitList(munitService.getEmbAll());
	}

	public List<Material> getMaterialList()
	{
		return materialList;
	}

	public void setMaterialList(List<Material> materialList)
	{
		this.materialList = materialList;
	}

	public List<Material> getFullMaterialList()
	{
		return fullMaterialList;
	}

	public void setFullMaterialList(List<Material> fullMaterialList)
	{
		this.fullMaterialList = fullMaterialList;
	}

	public boolean isActiveFilterMaterial()
	{
		return activeFilterMaterial;
	}

	public void setActiveFilterMaterial(boolean activeFilterMaterial)
	{
		this.activeFilterMaterial = activeFilterMaterial;
	}

	public Material getFilterTmpMaterial()
	{
		return this.filterTmpMaterial;
	}

	private void setFilterTmpMaterial(Material material)
	{
		this.filterTmpMaterial = material;
	}

	public MaterialFilter getDataFilterMaterial()
	{
		return dataFilterMaterial;
	}

	public void setDataFilterMaterial(MaterialFilter dataFilterMaterial)
	{
		this.dataFilterMaterial = dataFilterMaterial;
	}

	public List<ServiceItem> getServiceItemList()
	{
		return serviceItemList;
	}

	public void setServiceItemList(List<ServiceItem> serviceItemList)
	{
		this.serviceItemList = serviceItemList;
	}

	public List<ServiceItem> getFullServiceItemList()
	{
		return fullServiceItemList;
	}

	public void setFullServiceItemList(List<ServiceItem> fullServiceItemList)
	{
		this.fullServiceItemList = fullServiceItemList;
	}

	public boolean isActiveFilterService()
	{
		return activeFilterService;
	}

	public void setActiveFilterService(boolean activeFilterService)
	{
		this.activeFilterService = activeFilterService;
	}

	public ServiceItem getFilterTmpService()
	{
		return this.filterTmpService;
	}

	private void setFilterTmpService(ServiceItem serviceItem)
	{
		this.filterTmpService = serviceItem;
	}

	public ServiceItemFilter getDataFilterService()
	{
		return dataFilterService;
	}

	public void setDataFilterService(ServiceItemFilter dataFilterService)
	{
		this.dataFilterService = dataFilterService;
	}

	public RequirementSubject getSelectedItem()
	{
		return selectedItem;
	}

	public void setSelectedItem(RequirementSubject selectedItem)
	{
		this.selectedItem = selectedItem;
	}

	public List<MUnitEmb> getMunitList()
	{
		return munitList;
	}

	public void setMunitList(List<MUnitEmb> munitList)
	{
		this.munitList = munitList;
	}

	@Command
	@NotifyChange({ "activeFilterMaterial", "materialList", "selectedItem" })
	public void onFilterMaterial()
	{
		this.setSelectedItem(null);

		this.setActiveFilterMaterial(!this.isActiveFilterMaterial());

		if (this.isActiveFilterMaterial())
		{
			this.doFilterMaterial();
		}
		else
		{
			this.setMaterialList(this.getFullMaterialList());
		}
	}

	@Command
	@NotifyChange("materialList")
	public void doFilterMaterial()
	{
		this.setSelectedItem(null);
		List<Material> result = this.materialService.filterList(this.getFullMaterialList(), this.getDataFilterMaterial());
		this.setMaterialList(result);
	}

	@Command
	@NotifyChange({ "activeFilterService", "serviceItemList", "selectedItem" })
	public void onFilterService()
	{
		this.setSelectedItem(null);

		this.setActiveFilterService(!this.isActiveFilterService());

		if (this.isActiveFilterService())
		{
			this.doFilterService();
		}
		else
		{
			this.setServiceItemList(this.getFullServiceItemList());
		}
	}

	@Command
	@NotifyChange("serviceItemList")
	public void doFilterService()
	{
		this.setSelectedItem(null);
		List<ServiceItem> result = this.serviceItemService.filterList(this.getFullServiceItemList(), this.getDataFilterService());
		this.setServiceItemList(result);
	}
}
